/* Sentinel - IRC Statistical and Operator Services
** s_string.h - String management functions
**
** Copyright W. Campbell and others.  See README for more details
** Some code Copyright: Jonathan George, Kai Seidler, ircd-hybrid Team,
**                      IRCnet IRCD developers.
**
** $Id: slog.h,v 1.3 2003/11/24 14:17:28 wcampbel Exp $
*/

#ifndef SLOG_H
#define SLOG_H

#include "token.h"

#define LOG_TIMEFMT	"%H:%M[%m/%d/%Y]"
#define LOG_LINE	80
#define MAX_LOGS	10
#define DEFAULT_LOG	0
#define LOG_FILE_LEN	256
#define LOG_BUFSIZE	512

/* L_NONE is to do NO stats logging */
#define L_NONE          0
#define L_DEBUG         1
#define L_INFO          2
#define L_NOTICE        3
#define L_WARNING       4
#define L_ERR           5
#define L_CRIT          6
#define L_ALERT         7
#define L_EMERG         8

extern struct Token log_levels[];

void slog(int, int, char *, ...);
void init_logsystem(void);
int init_log(int, char *, int, char *);
int fini_log(int);
void set_logdebug(int);
void set_loglevel(int, int);
void set_logts(int, int);
void close_logfiles(void);
void ResetLogs(void);
void FlushLogs(void);

#endif
